namespace BookWorm {

	public class BookWormApplication : Granite.Application
	{
		BookWormWindow window;

		construct {
			program_name = "BookWorm";
			exec_name = "bookworm";
		}

		public BookWormApplication (string[] args)
		{
			Gtk.init (ref args);
			string filename = "";
			if (args.length > 1) {
				filename = args[1];
			}
			window = new BookWormWindow (filename, this);
			window.show ();
			window.destroy.connect (Gtk.main_quit);
		}
	}

	private static Gdk.Pixbuf default_cover = null;
	private static string data_dir = null;

	public static string get_data_dir() {
		if(data_dir != null)
			return data_dir;

		string result = Environment.get_user_data_dir ();
		if (result == "")
			result = Environment.get_home_dir () + ".local/share/";

		if (!result.has_suffix ("/"))
			result += "/";
		result += "bookworm/";
		data_dir = result;
		return data_dir;
	}

	public static unowned Gdk.Pixbuf get_default_cover () {
		if (default_cover != null)
			return default_cover;
		try {
		default_cover = new Gdk.Pixbuf.from_file_at_scale (
					"/usr/local/share/bookworm/default.png",
					LibraryView.ICON_W, LibraryView.ICON_H, true);
		} catch {
			try {
				default_cover = new Gdk.Pixbuf.from_file_at_scale (
						"/usr/share/bookworm/default.png",
						LibraryView.ICON_W, LibraryView.ICON_H, true);
			} catch {
				error ("No default cover found!");
			}
		}
		return default_cover;
	}


	public static int main (string[] args) {
		GtkClutter.init (ref args);
	
		new BookWormApplication (args);
		Gtk.main();
		return 0;
	}
}
